c Traces rays in dipping layered transversely isotropic models and
c symmetry axis not necessarily vertical. Takes into account well
c deviation. It does connect (links) sources and receivers.
	parameter (nsources=9000,nrec_per_source=200)
	parameter (nlayers=500,nmaxray=12000)
	real zshot(nsources),xshot(nsources),gammafix(nlayers),
     *	dip(nlayers+1),zborder(nlayers+1),
     *	rec(nrec_per_source,nsources),horpos(nrec_per_source),
     *	zrec_real(nmaxray),zrec(nmaxray),beta0(nmaxray),
     *	beta02(nmaxray),time(nlayers),x(nlayers),z(nlayers),
     *	total_time(nmaxray)
c	character*90 file
	integer nrec(nmaxray),i_mark_point(nlayers)
	common/pi/pi
        common/elast/ea(nlayers),ec(nlayers),el(nlayers),ef(nlayers)
        common/newelast/aa,bb,cc,dd,erho
	common/pio2/pio2,pio180
	common/epsilon/epsilon
	common/critical/zfinal(nlayers),isour_rel_layer(nlayers)
	common/icrit/icrit
	common/wavetype/wavesign
	namelist /parameters/anglemin,anglemax,nrays,i_which_shot,
     *	want_capture,nmax_iter
	namelist /ti_model/nl,ea,ec,ef,el,gammafix,ellipt,wave,
     *	dip,zborder,dist
	character*1 want_capture,ellipt,wave

	wave='p'
c In files
c100	write(*,*) 'Velocity model ?'
c	read(*,'(a90)') file
c	open(1,file=file,err=100,status='old')
c **************
c The rays are traced from the receiver positions
	open(2,file=
     * 'only-receivers',status='old')
c **************
	open(3,
     *	file='ray_tracing.parms',status='old')
        open(14,file=
     * 'only-sources',status='old')

c Out file
	open(10,file='anisolayer_dip.out',
     *	form='unformatted',status='unknown')
	open(11,file='rays_1d.out',form='formatted',status='unknown')
	open(15,file='times_calc_ani.out',
     *	form='formatted',status='unknown')
	open(20,file='rays.H')
	
	read(2,*) nshot
	write(*,*) nshot
	if(nshot.gt.nsources) then
		write(*,*) 'more shots that the maximum allowed'
		write(*,*) 'increase the parameter nsources'	
		stop
	endif
	call readshots(xshot,zshot,nshot)

	epsilon=3.e-06
	pio2=asin(1.)
	pi=acos(-1.)
	pio180=pi/180.
c radius of capture
	radio=0.5
c icapture -->  counts the rays that has been captured
	icapture=0
c max number of iterations allowed to capture a ray
c	nmax_iter=30

	read(*,ti_model,err=888)
	goto 889
888	write(*,*) ' Error in the input file'
	stop
889	continue

c select the proper sign in fron of the square root depending on the
c wave type
	if(wave.eq.'p') then
		wavesign=+1.
	else if(wave.eq.'s') then
		wavesign=-1.
	else
		write(*,*) 'select the correct wavetype'
		stop
	endif

	erho=1.
	do i1=1,nl
		ea(i1)=(ea(i1))**2*erho
		ec(i1)=(ec(i1))**2*erho
		ef(i1)=(ef(i1))**2*erho
		el(i1)=(el(i1))**2*erho
	enddo
c *****
c When `ellipt' = `y', the elastic constant f is recalculated to make the
c model elliptically anisotropic in the following way
c f=sqrt((c-l)(a-l)) - l.  (Thomsen, 1986)
c In this case the P and S velocities are:
c Vp= (a sin^2(theta) + c cos^2(theta))/rho; Vs=l/rho.
c Moreover, if c=a, the model is isotropic with P and S velocities
c equal to:
c Vp= a/rho; Vs=l/rho.
c *****
	if(ellipt.eq.'y') then
	      do i1=1,nl
		ef(i1)=sqrt((ec(i1)-el(i1))*(ea(i1)-el(i1))) - el(i1)
	      enddo
	endif
	
c take the tangents of the dips of the layers (in degrees)
	do i1=1,nl+1
		dip(i1)=tan(dip(i1)*pio180)
	enddo
c checks if the model has been specified correctly: boundaries cannot cross
	call check_model(dip,zborder,nl,dist)
		do i1=1,nl
			gammafix(i1)=gammafix(i1)*pio180
		enddo	
		

        do  kk=1,nshot
c	i counts the shot number. 
        read(14,*) i,nrec(i)
	if(nrec(i).gt.nrec_per_source) then
        	write(*,*) 'source= ',i,' has ',nrec(i),' receivers'
		write(*,*) 'increase the parameter nrec_per_source'
		stop
	else
                call read_positions(nrec(i),rec(1,i),horpos)
	endif
	enddo

	i_real_time=0

c	i counts the shot number. New parameters are read for each shot
	do 500 i=1,nshot
		read(3,parameters)
	if(i_which_shot.eq.0) goto 1000
	if(i.ne.i_which_shot) goto 500
1000		write(*,*) i
		anglemin=(pio180)*anglemin
		anglemax=(pio180)*anglemax
c indexray=  counts the rays that are being traced for a given shot
c position
		indexray=0
		
c trace first fan of nrays rays
		call trace(indexray,i,xshot(i),zshot(i),dist,
     *			nl,gammafix,dip,zborder,anglemin,anglemax,nrays,
     *			beta0,zrec,x,z,ip,time,
     *			want_capture,i_mark_point,n_total_points,n_no_captured)
		if(want_capture.eq.'n') then
			write(20,307) n_total_points
			write(*,*) n_no_captured,' were traced'
307	format('n1=',i3,/,'n2=2',/,'n3=1',/,'ein=0',/,'in="rays_1d.out"')
			stop
		endif
		do kk=1,nrec(i)
			zrec_real(kk)=rec(kk,i)
		enddo
         do 300 kk=1,nrec(i)
c n_iter counts the number of iterations before capturing a ray
		n_iter=0
		call sort2(zrec,beta0,indexray)
		call  check_critical(zrec,beta0,indexray,radio,zrec_real(kk))
c interpolates to find the correct shooting angles for the real receiver
c locations zrec_real
		derivative_1=(beta0(2)-beta0(1))/(zrec(2)-zrec(1))
		derivative_n=
     *			    (beta0(indexray)-beta0(indexray-1))/
     *			    (zrec(indexray)-zrec(indexray-1))
c checks where different beta values produce the same zrec (critical
c angle). 
		call spline(zrec,beta0,indexray,derivative_1,
     *			    derivative_n,beta02)
c         do 300 kk=1,nrec(i)
		if(zrec_real(kk).gt.zrec(indexray).or.
     *		   zrec_real(kk).lt.zrec(1)) then
c	write(*,*) 'no capture for source ',i,' and receiver ',kk
c	write(*,*) 'try increasing anglemax, anglemin or nrays'
			i_real_time=i_real_time + 1
			total_time(i_real_time)=0.
		goto 300
		endif
200		call splint(zrec,beta0,beta02,indexray,zrec_real(kk),
     *		            beta_new)
			call trace(indexray,i,xshot(i),zshot(i),dist,
     *				nl,gammafix,dip,zborder,beta_new,
     *				anglemax,1,beta0,zrec,x,z,ip,time,
     *				want_capture,i_mark_point,n_total_points,
     *				n_no_captured)
c checks if the ray has been captured
		if(abs(zrec(indexray)-zrec_real(kk)).lt.radio) then
c i_real_time= counts the all the rays captured or not 
c if total_time(i_real_time) is zero, it means that the ray that corresponds
c to that source-receiver pair was not captured
			i_real_time=i_real_time + 1
			icapture=icapture+1
			call write_ray(x,z,ip,time,kk,i_real_time,i_mark_point)
			total_time(i_real_time)=time(ip)*1000
			indexray=indexray-1
		else
			n_iter=n_iter+1
			if(n_iter.eq.nmax_iter) then
	write(*,*) 'no capture for source ',i,' and receiver ',kk 
			i_real_time=i_real_time + 1
			total_time(i_real_time)=0.
			goto 300
			endif
			call sort3(zrec,beta0,indexray)
			call  check_critical(zrec,beta0,indexray,radio,
     *						zrec_real(kk))
c interpolates again
		derivative_1=(beta0(2)-beta0(1))/(zrec(2)-zrec(1))
		derivative_n=
     *			    (beta0(indexray)-beta0(indexray-1))/
     *			    (zrec(indexray)-zrec(indexray-1))
		call spline(zrec,beta0,indexray,derivative_1,
     *			    derivative_n,beta02)
		goto 200
		endif
300	  continue

500	continue
	call write_times(i_real_time,total_time)

	write(*,*) icapture,' rays has been captured'
	write(*,*) 'output files: anisolayer_dip.out'
	write(*,*) 'and         : times_calc_ani.out'
	stop
	end

	subroutine trace(indexray,i,xshot,zshot,xmax,
     *	nl,gammafix,dip,zborder,anglemin,anglemax,nrays,beta0,zrec,
     *	x,z,ip,time,want_capture,i_mark_point,n_total_points,
     *	n_no_captured)
	parameter (nlayers=500)
	parameter (nmaxray=12000)
	common/pi/pi
	common/pio2/pio2,pio180
	common/normal/normal
	common/epsilon/epsilon
	common/critical/zfinal(nlayers),isour_rel_layer(nlayers)
	common/icrit/icrit
        common/elast/ea(nlayers),ec(nlayers),el(nlayers),ef(nlayers)
        common/newelast/aa,bb,cc,dd,erho
	real dip(nl+1),zborder(nl+1),x(nlayers),time(nlayers),
     *	z(nlayers),z_ph(nlayers),x_ph(nlayers),
     *	normal(2),gammafix(nl),length,ph_vector(2),
     *	zshot,len,ray_vector(2),xshot,beta0(nmaxray),zrec(nmaxray)
	integer i_mark_point(nlayers)
	common/wavetype/wavesign
	character*1 want_capture
c these two parameters are needed to plot the rays and nothing else.
	n_no_captured=0
	n_total_points=0
	
c **
c The equation of the ray is z=slope x + ord
c The equation of the boundary is z=dip*x+zborder
c **

c	i counts the shot number. New parameters are read for each shot
c	i=1

	if(anglemin.eq.anglemax) then
		write(*,*) 'anglemin = anglemax. Wrong !'
		stop
	endif
	if(nrays.eq.1) then
		dangle=0.
	else
		dangle=(anglemax-anglemin)/(nrays-1)
	endif

c finds the layer where the source is located
		do kk=1,nl
                if(zshot.ge.(zborder(kk)+xshot*dip(kk)).and.
     *             zshot.lt.(zborder(kk+1)+xshot*dip(kk+1))) then
c the source is located at nlay
		nlay=kk
		goto 20
		endif
		enddo
20		continue

		thetavmin=anglemin-gammafix(nlay)
		thetavmax=anglemax-gammafix(nlay)

		do 10 j=1,nrays
c icrit --> counts the rays that end at the other well at a critical
c angle for a given interface
			icrit=1
			ip=1
			time(1)=0.
			thetaold=theta
			phiold=phi
c beta=angle of the incident wavefront with respect to the vertical
			beta=anglemin+dangle*(j-1)
			thetav=beta-gammafix(nlay)
			call phase_group('t',nlay,thetav,vphase,phi,vray)
c			write(*,*) phi*180/pi,thetav*180/pi
			if(nrays.gt.1) then
			if(phi.lt.thetavmin.or.phi.gt.thetavmax) goto 10
			endif
			arayold=aray
			aray=phi+gammafix(nlay)-pio2
c		write(*,*) 'aqui ',thetav,vphase,vray,aray*180/pi
			aphase=thetav+gammafix(nlay)-pio2
c			if(phi.eq.0..and.angle.eq.pio2) aray=pio2

			slope=cal_slope(aray)
			slope_ph=cal_slope(aphase)
			ord=zshot-slope*xshot
			ord_ph=zshot-slope_ph*xshot
c ******
			ang=aray
			ang_ph=aphase
c ******
			x(ip)=xshot
			z(ip)=zshot
			x_ph(ip)=xshot
			z_ph(ip)=zshot
			i_mark_point(ip)=nlay
			ip=ip+1
			if(angle(slope,dip(nlay+1)).ne.0.) then
c xbelow --> intersection of the ray with the boundary below the source
			xbelow=(zborder(nlay+1)-ord)/(slope-dip(nlay+1))
			else
			xbelow=xshot
			endif
			if(angle(slope,dip(nlay)).ne.0.) then
c xup --> intersection of the ray with the boundary above the source
			xup=(zborder(nlay)-ord)/(slope-dip(nlay))
			else
			xup=xshot
			endif
			if(xbelow.gt.xshot.and.xbelow.lt.xmax) then
				linitial=nlay+1
				lfinal=nl
				incre=1
				ioz=0
			else if(xup.gt.xshot.and.xup.lt.xmax) then
				linitial=nlay-1
				lfinal=1
				incre=-1
				ioz=1
			else if(abs(abs(aray)-pio2).le.epsilon) then
				if(aray.gt.0.) then
					linitial=nlay+1
					lfinal=nl
					incre=1
					ioz=0
				else
					linitial=nlay-1
					lfinal=1
					incre=-1
					ioz=1
				endif
			else
				z(ip)=slope*xmax+ord
				x(ip)=xmax
				i_mark_point(ip)=nlay
				l=nlay
				incre=0
				ioz=0
				len=length(x,z,ip)
				time(ip)=len/vray
				goto 3
			endif
c
c do from the initial layer (where the source is located ) 
c to the final layer (where the receiver is located).
			do 2 l=linitial,lfinal,incre
		x(ip)=(zborder(l+ioz)-ord)/(slope-dip(l+ioz))
		x_ph(ip)=(zborder(l+ioz)-ord_ph)/(slope_ph-dip(l+ioz))
		i_mark_point(ip)=l+ioz
					if(abs(abs(ang)-pio2).lt.epsilon) then
						z(ip)=zborder(l+ioz)
					else
						x(ip)=amin1(x(ip),xmax)
						z(ip)=x(ip)*slope+ord
					if(x(ip).lt.0.) then
						call vector(x,z,ip,ray_vector)
						normal(1)=-normal(1)
						normal(2)=-normal(2)
					sig=adotb(ray_vector,normal)
						if(sig.lt.0.) then
							x(ip)=xmax
							z(ip)=x(ip)*slope+ord
						endif
					endif
					endif

				if(abs(abs(ang_ph)-pio2).lt.epsilon) then
						z_ph(ip)=zborder(l+ioz)
					else
c						x_ph(ip)=amin1(x_ph(ip),xmax)
					z_ph(ip)=x_ph(ip)*slope_ph+ord_ph
					if(x_ph(ip).lt.0.) then
					call vector(x_ph,z_ph,ip,ph_vector)
					sig=adotb(ph_vector,normal)
						if(sig.lt.0.) then
c						x_ph(ip)=xmax
					      z_ph(ip)=x(ip)*slope_ph+ord_ph
						endif
					endif
					endif
					if(x(ip).eq.xmax) then
						len=length(x,z,ip)
						time(ip)=time(ip-1)+len/vray
						goto 3
					endif

c finds a vector pointing in the direction of the incident phase
				call vector(x_ph,z_ph,ip,ph_vector)

c checks if the incident phase points towards the interface (r=1) or
c not (r=0) even when the incident ray does. If r=0, there is not
c transmitted but reflected ray and the solution here is to consider
c such a ray as critical (traveling along the interface).
                                r=1
                            call check_phase_vector(aphase,ph_vector,r)
                                if(r.eq.0.) then
                                        ip=ip+1
                                        x(ip)=xmax
					z(ip)=dip(l+ioz)*xmax+zborder(l+ioz)
					i_mark_point(ip)=l+ioz
                                        zfinal(icrit)=z(ip)
                                        isour_rel_layer(icrit)=incre
                                        icrit=icrit+1
				else if(r.lt.0.) then
					goto 10
                                endif

					len=length(x,z,ip)
					time(ip)=time(ip-1)+len/vray

					if(x(ip).eq.xmax) goto 3

					ang_layer=atan(dip(l+ioz))
					gammavar=gammafix(l-incre)-ang_layer
					gammavar_out=gammafix(l)-ang_layer
					ang_before=angle(slope_ph,dip(l+ioz))
					ang_before=abs(pio2-ang_before)
c finds a vector pointing in the direction of the incident phase
c					call vector(x_ph,z_ph,ip,ph_vector)
c find the sign of the incident angle (ang_before) with respect to the normal
					sig=signo(dip(l+ioz),ph_vector)
					ang_before=sig*ang_before
				        p=sin(ang_before)/vphase
		call find_new_theta(p,l,gammavar_out,theta,theta_crit)
				call phase_group('t',l,theta,vphase,phi,vray)

c avoids reflected rays when the refracted phase travels along the interface.
				if(normal(2).gt.0.) then
					phi=amin1(phi,theta_crit)
				else
					phi=amax1(phi,theta_crit)
				endif

				aray=phi+gammafix(l)+sign(pio2,-normal(2))
				aphase=theta+gammafix(l)+sign(pio2,-normal(2))
				ang=aray
				ang_ph=aphase
				slope=cal_slope(ang)
				slope_ph=cal_slope(ang_ph)
				ord=z(ip)-slope*x(ip)
				ord_ph=z_ph(ip)-slope_ph*x_ph(ip)
				ip=ip+1
				ang_lay_ray=angle(slope,dip(l+ioz))
				ang_lay_phase=angle(slope_ph,dip(l+ioz))
c checks if the ray is parallel to the boundary
			   if(ang_lay_ray.eq.0.or.ang_lay_phase.eq.0.) then
					z_ph(ip)=slope_ph*xmax+ord_ph
					x_ph(ip)=xmax
					z(ip)=dip(l+ioz)*xmax+zborder(l+ioz)
					x(ip)=xmax
					i_mark_point(ip)=l+ioz
					len=length(x,z,ip)
c					time(ip)=time(ip-1)+len/vray
					time(ip)=0.
					zfinal(icrit)=z(ip)
					isour_rel_layer(icrit)=incre
					icrit=icrit+1
					goto 3
			   endif
2			continue
		x(ip)=(zborder(lfinal-ioz+1)-ord)/(slope-dip(lfinal-ioz+1))
		i_mark_point(ip)=lfinal-ioz+1
			if(abs(abs(ang)-pio2).lt.epsilon) then
				z(ip)=zborder(lfinal-ioz+1)
			else
				x(ip)=amin1(x(ip),xmax)
				z(ip)=x(ip)*slope+ord
				if(x(ip).lt.0.) then
					call vector(x,z,ip,ray_vector)
					normal(1)=-normal(1)
					normal(2)=-normal(2)
					sig=adotb(ray_vector,normal)
					if(sig.lt.0.) then
						x(ip)=xmax
						z(ip)=x(ip)*slope+ord
					endif
				endif
			endif
			len=length(x,z,ip)
			time(ip)=time(ip-1)+len/vray
3		continue
c the ray didn't reach the other well.
		i_mark_point(ip)=l+ioz-(1-ioz)*incre
		if(x(ip).lt.xmax.and.want_capture.eq.'y') goto 10
		indexray=indexray+1
		zrec(indexray)=z(ip)
		beta0(indexray)=beta
		if(want_capture.eq.'n') then
			n_no_captured=n_no_captured+1
			n_total_points=n_total_points+ip
			call write_ray(x,z,ip,time,indexray,0,i_mark_point)
		endif
c		call write_ray(x,z,ip,time,indexray)
10		continue
c	enddo
c	i=i+1
c	goto 111
c100	continue
	return
	end


	function cal_slope(angle)
	common/epsilon/epsilon
	common/pio2/pio2,pio180
	if(abs(abs(angle)-pio2).gt.epsilon) then
		cal_slope=tan(angle)
	else if(angle.gt.0.) then
		cal_slope=1.e+15
	else
		cal_slope=-1.e+15
	endif
	return
	end


	function signo(dip,ray_vector)
c dip ---> slope of the equation of the boundary (z= dip*x + zborder)
c ray_vector ---> vector pointing in the direction of the incident ray
	real normal(2),ray_vector(2)
	common/normal/normal
	normal(1)=-dip
	normal(2)=1.
c finds the normal pointing outwards from the boundary (with respect to the
c incident ray)
	if(adotb(normal,ray_vector).gt.0.) then
		normal(1)=-normal(1)
		normal(2)=-normal(2)
	endif
	signo=acrossb(ray_vector,normal)
	return
	end

	
	function signodot(dip,ray_vector)
c fins the sign of the scalar product between the vectors
c (-dip,1.) and ray_vector 
	real normal(2),ray_vector(2)
	normal(1)=-dip
	normal(2)=1.
	signodot=adotb(normal,ray_vector)
	if(signodot.gt.0.) then
		signodot=1.
	else
		signodot=-1.
	endif
	return
	end


	function acrossb(a,b)
	real a(2),b(2)
c performs the vector product aXb. a and b are both in the vertical plane 
c This is used to find out the sign (signo) of the angle between the normal
c and the incident ray
	acrossb=a(1)*b(2)-a(2)*b(1)
	if(acrossb.ge.0.) then
		acrossb=1.
	else
		acrossb=-1.
	endif
	return
	end

		
	subroutine vector(x,z,ip,vec)
c find a vector from the point (ip-1) to the point (ip)
	real x(ip),z(ip),vec(2)
	vec(1)=x(ip)-x(ip-1)
	vec(2)=z(ip)-z(ip-1)
	return
	end


	function adotb(a,b)
c performs the scalar product a.b
	real a(2),b(2)
	adotb=a(1)*b(1)+a(2)*b(2)
	return
	end


	subroutine check_model(dip,z0,nl,xmax)
	parameter (nlayers=500)
        common/elast/a(nlayers),c(nlayers),l(nlayers),f(nlayers)
        real l
	real dip(nl+1),z0(nl+1)
	do i=1,nl
		if(dip(i).ne.dip(i+1)) then
			xi=(z0(i)-z0(i+1))/(dip(i+1)-dip(i))
			if(xi.gt.0.and.xi.lt.xmax) then
			write(*,*) 'boundaries ',i,' and',i+1,' cross at ',xi,
     *	dip(i)*xi+z0(i)
				stop
			endif
		endif
	enddo
        do i=1,nl
        if(a(i).lt.c(i)) then
             write(*,*) 'Error in the elastic constants for layer', i
             write(*,*) '(C < A)'
             stop
c see comment in function cphic
        endif
        enddo
	return
	end

        function cphit(vphase,dvphase,theta)
        cphit=atan(dvphase/vphase)+theta
        return
        end

        function cphic(vphase,vray,theta)
        common/pi/pi
c The ray angle is closer to the largest velocity, for a given phase
c angle.
c Here:         (theta < phi) for (theta < pio2) and
c               (theta > phi) for (theta > pio2).
c This is true if V(pio2) > V(0). For this reason, the elastic
constants
c A and C must satisfy A > C (or equal).
        if(theta.le.(pi/2.).or.theta.gt.pi) then
                cphic=theta+(acos(vphase/vray))*sign(1.,theta)
c               cphic=theta+(acos(vphase/vray))
        else
                cphic=theta-acos(vphase/vray)
        endif
        return
        end
	

	function angle(aray,alayer)
c finds the angle between the lines y-aray*x=0  and  y-alayer*x=0
	common/pi/pi
	common/epsilon/epsilon
	if(abs(aray-alayer).le.epsilon) then
		angle=0.
		return
	endif
	sizeray=sqrt(1.+aray*aray)
	sizelayer=sqrt(1.+alayer*alayer)
	raydotlayer=1+aray*alayer
	if(abs(sizeray*sizelayer-raydotlayer).le.epsilon) then
		angle=0.
	else
		angle=acos(raydotlayer/(sizeray*sizelayer))
	endif
	if(abs(angle-pi).le.epsilon) angle=0.
c	if(angle.gt.pio2) angle=pi-angle
	return
	end


	real function length(x,z,ip)
	real x(ip),z(ip)
	xx=(x(ip)-x(ip-1))*(x(ip)-x(ip-1))
	zz=(z(ip)-z(ip-1))*(z(ip)-z(ip-1))
	length=sqrt(xx+zz)
	return
	end


	subroutine write_ray(x,z,n,time,indexray,number_of_ray,
     *	i_mark_point)
	real x(n),z(n),time(n)
	integer i_mark_point(n)
	write(13,'(i1,",")') n
c	write(13,*) n
c	write(11,*) n
	do i=1,n
	write(11,*) x(i),z(i)
c	write(12,*) x(i),z(i)
c	write(*,*) x(i),z(i)
	enddo
c	write(60,*) sqrt((x(2)-x(1))**2 + (z(2)-z(1))**2)/time(2),
c     *	atan( (z(2)-z(1))/(x(2)-x(1)))*180/acos(-1.)
	if(n.eq.2) then
		i_mark_point(2)=i_mark_point(2)+1
c if i_mark_point(1)=i_mark_point(2) the ray goes upwards (from lower
c layers to upper layers).
	else if(i_mark_point(1).eq.i_mark_point(2)) then
		i_mark_point(1)=i_mark_point(1)+1
c if i_mark_point(n)=i_mark_point(n-1) the ray goes downwards (from upper
c layers to lower layers).
	else if(i_mark_point(n).eq.i_mark_point(n-1)) then
		i_mark_point(n)=i_mark_point(n)+1
	endif
	do i=1,n-1
	number_of_layer=min0(i_mark_point(i),i_mark_point(i+1))
	write(10) number_of_layer,i_mark_point(i),number_of_ray,x(i),z(i),
     *	time(i+1)-time(i)
	enddo
	write(10) number_of_layer,i_mark_point(n),number_of_ray,x(n),z(n)
     *	,0.
	return
	end	

        function ang_ray(phi,gammafix)
c calculates the angle from the horizontal to the ray. This angle is
c used later to calculate the slope A of the equation of the ray y=Ax+b
        common/pio2/pio2,pio180
	ang_ray=phi+gammafix-pio2
        return
        end

        function dv_phase(theta,i)
        parameter (nlayers=500)
        common/elast/a(nlayers),c(nlayers),l(nlayers),f(nlayers)
        common/newelast/aa,bb,cc,dd,rho
        common/sincos/stheta2,ctheta2,s2theta2
        common/discri/discri
	common/wavetype/wavesign
        real num,num1,num2,l
        den=v_phase(theta,i)*2.
        stheta=sin(theta)
        ctheta=cos(theta)
        s2theta=sin(2.*theta)
        c2theta=cos(2.*theta)
        num1=(bb-cc)*stheta*ctheta
	if(discri.ne.0.) then
        	num2=(bb-cc)*(bb*stheta2 + cc*ctheta2)*stheta*ctheta
        	num2=(num2 - dd*s2theta*c2theta)/sqrt(discri)
	else
		num2=0.
	endif
        num=num1 + wavesign*num2
        dv_phase=num/den
        return
        end
 
        function v_phase(theta,i)
        parameter (nlayers=500)
        common/elast/a(nlayers),c(nlayers),l(nlayers),f(nlayers)
        common/newelast/aa,bb,cc,dd,rho
        common/sincos/stheta2,ctheta2,s2theta2
        common/discri/discri
	common/wavetype/wavesign
        real l
        oneorho=1./rho
        aa=l(i)*oneorho
        bb=(a(i) - l(i))*oneorho
        cc=(c(i) - l(i))*oneorho
        dd=(a(i) - l(i))*(c(i) - l(i))
        dd=( dd - (f(i) + l(i)) * (f(i) + l(i)) )*oneorho*oneorho
        stheta2=sin(theta)*sin(theta)
        ctheta2=cos(theta)*cos(theta)
        s2theta2=sin(2.*theta)*sin(2.*theta)
        discri=(bb*stheta2 + cc*ctheta2)**2 - dd*s2theta2
        vvby2=2.*aa + bb*stheta2 + cc*ctheta2
        vvby2=vvby2 + wavesign*sqrt(discri)
        v_phase=sqrt(vvby2*0.5)
        return
        end

 
	subroutine phase_group(way,i,theta,vphase,phi,vray)
        parameter (nlayers=500)
        common/elast/a(nlayers),c(nlayers),l(nlayers),f(nlayers)
        common/newelast/aa,bb,cc,dd,rho
        common/sincos/stheta2,ctheta2,s2theta2
        common/discri/discri
	common/pio2/pio2,pio180
	common/epsilon/epsilon
	common/pi/pi
	common/wavetype/wavesign
	character*1 way
        vphase=v_phase(theta,i)
        dvphase=dv_phase(theta,i)
c selects how the angle is going to be calculated, because the domains
c of tan and cos are different in fortran ( i think !!).
c -cphic uses the expression with the acos
c -cphit uses the expression with the atan
	if(abs(theta-pio2).le.epsilon) then
		phi=pio2
		vray=vphase
        else if(way.eq.'c') then
                vray=v_ray_sq(vphase,dvphase)
                phi=cphic(vphase,vray,theta)
        else
                phi=cphit(vphase,dvphase,theta)
                vray=v_ray(theta,phi,vphase)
        endif
        return
        end

        function v_ray_sq(vphase,dvphase)
        v_ray_sq=sqrt(vphase*vphase+dvphase*dvphase)
        return
        end

        function v_ray(theta,phi,vphase)
        v_ray=vphase/cos(phi-theta)
        return
        end

        subroutine find_new_theta(p,i,gamma,theta,theta_crit)
c solves the fourth order polinomial in tan(theta) and choose the
c proper root.
        parameter (nlayers=500)
        common/elast/a(nlayers),c(nlayers),l(nlayers),f(nlayers)
        common/newelast/aa,bb,cc,dd,rho
        common/epsilon/epsilon
        common/pio2/pio2,pio180
        common/pi/pi
        common/normal/normal(2)
	common/wavetype/wavesign
c        complex*16 coeff(5),rootsd(4)
        complex roots(4),coeff(5)
        real l,all_roots(8),theta_almost(4),normal,error_p(4)
        logical polish
                theta_crit=sign(pio2,normal(2))-gamma
c wavefront normal (or almost normal) to the interface (p~0)
        if(abs(p).le.3.*epsilon) then
c               theta=-gamma
                theta=asin(p*v_phase(-gamma,i))-gamma
                return
        endif
        oneorho=1./rho
        aa=l(i)*oneorho
        bb=(a(i)-l(i))*oneorho
        cc=(c(i)-l(i))*oneorho
        dd=(a(i)-l(i))*(c(i)-l(i))
        dd=( dd - (f(i) + l(i)) * (f(i) + l(i)) )*oneorho*oneorho
        p2=p*p
        p4=p2*p2
        singamma2=sin(gamma)*sin(gamma)
        sin2gamma=sin(2.*gamma)
        sin2gamma2=sin2gamma*sin2gamma
        cosgamma2=cos(gamma)*cos(gamma)
        t0=2.*singamma2 - p2*(cc + 2.*aa)
        t1=2.*sin2gamma
        t2=2.*cosgamma2 - p2*(bb+2.*aa)
        coeff(1)=(cc*cc*p4-t0*t0)
        coeff(2)=(-2.*t1*t0)
        coeff(3)=(2.*bb*cc*p4 - 4.*dd*p4 - t1*t1-2.*t2*t0)
        coeff(4)=(-2.*t2*t1)
        coeff(5)=(p4*bb*bb-t2*t2)

        polish=.true.
c	write(*,*) i
        call zroots(coeff,4,roots,polish)

	nimag=0
c aimag(roots).ne. 0 ---> critical angle
        do j=1,4
                if(aimag(roots(j)).ne.0.)  then
			nimag=nimag+1
                endif
        enddo
c the imaginary roots correspond to P waves
	if(nimag.ge.2.and.wavesign.eq.1.) then
		theta=theta_crit
		return
c the imaginary roots correspond to S waves
	else if(nimag.eq.4) then
		theta=theta_crit
		return
	endif
		

c finds all possible roots by adding +- pi to the given ones
        kk=1
        do j=1,4
c all_roots is measured from the normal
c roots is measured from the axis of symmetry
        all_roots(kk)=atan(real(roots(j)))+gamma
                if(all_roots(kk).lt.0.) then
                        all_roots(kk+1)=all_roots(kk)+pi
                else
                        all_roots(kk+1)=all_roots(kk)-pi
                endif
        kk=kk+2
        enddo

        ii=0
c finds theta by comparing with p of the incident phase
        do j=1,8
                theta_test=(all_roots(j)-gamma)
                p_new=sin(theta_test+gamma)/v_phase(theta_test,i)
                if(abs(p-p_new).le.epsilon) then
c		write(*,*) theta_test,v_phase(theta_test,i),p_new-p,ii
                        if(ii.eq.4) then
              write(*,*) 'more than four phase angles OK for the same p'
              write(*,*) 'this ray might be incorrect'
                                pause
                        else
                        ii=ii+1
                        theta_almost(ii)=theta_test
                        error_p(ii)=abs(p-p_new)
                        endif
                endif
        enddo

	if(ii.gt.2) then
		call sort3(error_p,theta_almost,ii)
c 4 angles OK for the same p. Chooses the two that give a p closer to
c the incident p
		write(*,*)  ii,' angles OK for the same p. Chooses 2.'
	write(*,*) error_p,theta_almost,ii
c	pause
	endif
	

        do j=1,2
        if(normal(2).lt.0.)  then
                theta_almost(j)=amax1(theta_crit,theta_almost(j))
                theta_almost(j)=amin1(theta_crit+pi,theta_almost(j))
        else
                theta_almost(j)=amin1(theta_crit,theta_almost(j))
                theta_almost(j)=amax1(theta_crit-pi,theta_almost(j))
        endif
        enddo

        if(abs(theta_almost(1)+gamma).gt.abs(theta_almost(2)+gamma))
     * then
                theta=theta_almost(2)
        else
                theta=theta_almost(1)
        endif
        return
        end


	subroutine readshots(xshot,zshot,nshot)
	real xshot(nshot),zshot(nshot)
	do i=1,nshot
		read(2,*) xshot(i),zshot(i)
	enddo
	return
	end

        subroutine read_positions(nrec,rec,horpos)
        real rec(nrec),horpos(nrec)
        read(14,*) rec,horpos
c       write(*,*) rec
c       read(15,*) xsour,zsour
        return
        end

      SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2)
      PARAMETER (nmaxray=12000)
      DIMENSION X(N),Y(N),Y2(N),U(nmaxray)
c      IF (YP1.GT..99E30) THEN
c        Y2(1)=0.
c        U(1)=0.
c      ELSE
        Y2(1)=-0.5
        U(1)=(3./(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
c      ENDIF
      DO 11 I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.
        Y2(I)=(SIG-1.)/P
        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *      /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
11    CONTINUE
c      IF (YPN.GT..99E30) THEN
c        QN=0.
c        UN=0.
c      ELSE
        QN=0.5
        UN=(3./(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
c      ENDIF
      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)
      DO 12 K=N-1,1,-1
        Y2(K)=Y2(K)*Y2(K+1)+U(K)
12    CONTINUE
      RETURN
      END

      SUBROUTINE SPLINT(XA,YA,Y2A,N,X,Y)
      DIMENSION XA(N),YA(N),Y2A(N)
      KLO=1
      KHI=N
1     IF (KHI-KLO.GT.1) THEN
        K=(KHI+KLO)/2
        IF(XA(K).GT.X)THEN
          KHI=K
        ELSE
          KLO=K
        ENDIF
      GOTO 1
      ENDIF
      H=XA(KHI)-XA(KLO)
      IF (H.EQ.0.) PAUSE 'Bad XA input.'
      A=(XA(KHI)-X)/H
      B=(X-XA(KLO))/H
      Y_LIN=A*YA(KLO)+B*YA(KHI)
	y=y_lin+
     *      ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.
	if(ya(klo)-ya(khi).gt.0.) then
		if(y.ge.ya(klo).or.y.le.ya(khi))  y=y_lin
	else 
		if(y.le.ya(klo).or.y.ge.ya(khi))  y=y_lin
	endif
	bbb=y
      RETURN
      END



      SUBROUTINE INDEXX(N,ARRIN,INDX)
      DIMENSION ARRIN(N),INDX(N)
      DO 11 J=1,N
        INDX(J)=J
11    CONTINUE
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          INDXT=INDX(L)
          Q=ARRIN(INDXT)
        ELSE
          INDXT=INDX(IR)
          Q=ARRIN(INDXT)
          INDX(IR)=INDX(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            INDX(1)=INDXT
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1)))J=J+1
          ENDIF
          IF(Q.LT.ARRIN(INDX(J)))THEN
            INDX(I)=INDX(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        INDX(I)=INDXT
      GO TO 10
      END

      SUBROUTINE SORT3(RA,RB,N)
	parameter (nmaxray=12000)
      DIMENSION RA(N),RB(N),WKSP(nmaxray),IWKSP(nmaxray)
      CALL INDEXX(N,RA,IWKSP)
      DO 11 J=1,N
        WKSP(J)=RA(J)
11    CONTINUE
      DO 12 J=1,N
        RA(J)=WKSP(IWKSP(J))
12    CONTINUE
      DO 13 J=1,N
        WKSP(J)=RB(J)
13    CONTINUE
      DO 14 J=1,N
        RB(J)=WKSP(IWKSP(J))
14    CONTINUE
      RETURN
      END

	subroutine check_critical(z,beta,n,radio,z_true_rec)
	parameter (nmaxray=12000,nlayers=500)
	common /epsilon/epsilon
	common/critical/zfinal(nlayers),isour_rel_layer(nlayers)
	common/icrit/icrit
	real z(n),beta(n),z_work(nmaxray),beta_work(nmaxray)
	real z_equal(nmaxray),beta_equal(nmaxray),beta_aux(nmaxray)
	n_initial=n
	do i=1,n
		z_equal(i)=-1.
		z_work(i)=z(i)
		beta_work(i)=beta(i)
	enddo
	j=1
	do i=1,n-1
		if(abs(z_work(i)-z_work(i+1)).le.z_work(i)*epsilon) then
			i_equal=1
			z_equal(j)=z_work(i)
			beta_equal(j)=beta_work(i)
			j=j+1
		else
			if(i_equal.eq.1) then
				i_equal=0
				z_equal(j)=z_work(i)
				beta_equal(j)=beta_work(i)
				j=j+1
			endif
		endif
	enddo
	if(z_equal(1).eq.-1) then
		call asign_beta_z(z,z_work,0.,beta,beta_work,beta_final,
     *	n_initial,n)
		return
	else

	idim=1
	do 400 l=1,j-1
	if(abs(z_equal(l)-z_equal(l+1)).gt.z_equal(l)*epsilon) then
	do ib=1,idim
		beta_aux(ib)=beta_equal(l-idim+ib)
	enddo
	call sort(beta_aux,idim)
c	call sort(beta,j)
	do i=1,icrit-1
		if(zfinal(i).eq.z_equal(l)) then
			min_or_max=isour_rel_layer(i)
		goto 20
		endif
	enddo
20	continue
		if(min_or_max.eq.1) then
			if(z_true_rec.gt.z_equal(l)) then
				beta_final=beta_aux(idim)
			else
				beta_final=beta_aux(1)
			endif
		else
			if(z_true_rec.lt.z_equal(l)) then
				beta_final=beta_aux(1)
			else
				beta_final=beta_aux(idim)
			endif
		endif
		call asign_beta_z(z,z_work,z_equal(l),beta,beta_work,
     *	beta_final,n,n_initial)
	idim=1
	do i=1,n
		z_work(i)=z(i)
		beta_work(i)=beta(i)
	enddo
	n_initial=n
	else
	idim=idim+1
	endif
400	continue
	endif
	return
	end

	subroutine asign_beta_z(z,z_work,z_equal,beta,beta_work,
     *	beta_final,
     *	n,n_initial)
	common /epsilon/epsilon
	real z(n),beta(n),z_work(n_initial),beta_work(n_initial)
	m=1
	iasign=0
	do i=1,n_initial
		if(abs(z_work(i)-z_equal).gt.z_equal*epsilon) then
			z(m)=z_work(i)
			beta(m)=beta_work(i)
			m=m+1
		else if(iasign.eq.0) then
			z(m)=z_equal
			beta(m)=beta_final
			m=m+1
			iasign=1
		endif
	enddo
	n=m-1
	return
	end

	subroutine sort(arr,n)
	real arr(n)
	do 12 j=2,n
		a=arr(j)
		do 11 i=j-1,1,-1
			if(arr(i).le.a) goto 10
			arr(i+1)=arr(i)
11		continue
		i=0
10		arr(i+1)=a
12	continue
	return
	end


        subroutine check_phase_vector(angle,ph_vector,r)
        real ph_vector(2),unit_vector(2)
        unit_vector(1)=cos(angle)
        unit_vector(2)=sin(angle)
        sig=adotb(unit_vector,ph_vector)
c sig < 0. means that the vectors unit_vector and ph_vector are 
c antiparalel
        if(sig.lt.0.) r=0.
	if(sig.eq.0.) then
		r=-1.
		write(*,*) 'sig = 0'
	endif
        return
        end

      SUBROUTINE SORT2(RA,RB,N)
      DIMENSION RA(N),RB(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
       RA(I)=RRA
        RB(I)=RRB
      GO TO 10
      END

	subroutine write_times(n,times)
	real times(n)
c	write(15,*) n	
	write(15,*) times
	return
	end
        subroutine minmax(n,arr,camax,camin)
        real arr(n)
        camax=arr(1)
        do i=2,n
        camax=amax1(camax,arr(i))
        enddo
        camin=arr(1)
        do i=2,n
        camin=amin1(camin,arr(i))
        enddo
        return
        end

      SUBROUTINE ZROOTS(A,M,ROOTS,POLISH)
      PARAMETER (EPS=1.E-6,MAXM=101)
      COMPLEX A(*),ROOTS(M),AD(MAXM),X,B,C
      LOGICAL POLISH
      DO 11 J=1,M+1
        AD(J)=A(J)
11    CONTINUE
      DO 13 J=M,1,-1
        X=CMPLX(0.,0.)
       CALL LAGUER(AD,J,X,EPS,.FALSE.)
        IF(ABS(AIMAG(X)).LE.2.*EPS**2*ABS(REAL(X))) X=CMPLX(REAL(X),0.)
        ROOTS(J)=X
        B=AD(J+1)
        DO 12 JJ=J,1,-1
          C=AD(JJ)
          AD(JJ)=B
          B=X*B+C
12      CONTINUE
13    CONTINUE
      IF (POLISH) THEN
        DO 14 J=1,M
          CALL LAGUER(A,M,ROOTS(J),EPS,.TRUE.)
14      CONTINUE
      ENDIF
      DO 16 J=2,M
        X=ROOTS(J)
        DO 15 I=J-1,1,-1
          IF(REAL(ROOTS(I)).LE.REAL(X))GO TO 10
          ROOTS(I+1)=ROOTS(I)
15      CONTINUE
        I=0
10      ROOTS(I+1)=X
16    CONTINUE
      RETURN
      END

      SUBROUTINE LAGUER(A,M,X,EPS,POLISH)
      COMPLEX A(*),X,DX,X1,B,D,F,G,H,SQ,GP,GM,G2,ZERO,XX,WW
      LOGICAL POLISH
      PARAMETER (ZERO=(0.,0.),TINY=1.E-15,MAXIT=200)
      IF (POLISH) THEN
        DXOLD=CABS(X)
        NPOL=0
      ENDIF
      DO 12 ITER=1,MAXIT
        B=A(M+1)
        D=ZERO
        F=ZERO
        DO 11 J=M,1,-1
          F=X*F+D
          D=X*D+B
          B=X*B+A(J)
11      CONTINUE
        IF(CABS(B).LE.TINY) THEN
          DX=ZERO
        ELSE IF(CABS(D).LE.TINY.AND.CABS(F).LE.TINY)THEN
          DX=CMPLX(CABS(B/A(M+1))**(1./M),0.)
        ELSE
          G=D/B
          G2=G*G
          H=G2-2.*F/B
          XX=(M-1)*(M*H-G2)
          YY=ABS(REAL(XX))
          ZZ=ABS(AIMAG(XX))
          IF(YY.LT.TINY.AND.ZZ.LT.TINY) THEN
            SQ=ZERO
          ELSE IF (YY.GE.ZZ) THEN
          WW=(1.0/YY)*XX
            SQ=SQRT(YY)*CSQRT(WW)
          ELSE
            WW=(1.0/ZZ)*XX
            SQ=SQRT(ZZ)*CSQRT(WW)
          ENDIF
          GP=G+SQ
          GM=G-SQ
          IF(CABS(GP).LT.CABS(GM)) GP=GM
          DX=M/GP
        ENDIF
        X1=X-DX
        IF(X.EQ.X1)RETURN
        X=X1
        IF (POLISH) THEN
          NPOL=NPOL+1
          CDX=CABS(DX)
          IF(NPOL.GT.9.AND.CDX.GE.DXOLD)RETURN
          DXOLD=CDX
        ELSE
          IF(CABS(DX).LE.EPS*CABS(X))RETURN
        ENDIF
12    CONTINUE
c      PAUSE 'too many iterations'
      write(*,*) 'too many iterations trying to improve a root'
      RETURN
      END
